//Licensed Material - Property of IBM
//(C) Copyright IBM Corp. 2004 - All Rights Reserved
//
//DISCLAIMER:
//The following [enclosed] code is sample code created by IBM
//Corporation.  This sample code is not part of any standard IBM product
//and is provided to you solely for the purpose of assisting you in the
//development of your applications.  The code is provided 'AS IS',
//without warranty of any kind.  IBM shall not be liable for any damages
//arising out of your use of the sample code, even if they have been
//advised of the possibility of such damages.

//This class extends JFrame.  It was built using the JVE.  Demostrates
//use of RecordIOManager and ListManager beans to display contenets of
//remote DB table.

package com.ibm.etools.iseries.examples.dfu.LisManager.ve;

import java.awt.Cursor;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.access.AS400Exception;
import com.ibm.as400.access.AS400SecurityException;
import com.ibm.etools.iseries.ui.JFormattedTable;
import com.ibm.etools.iseries.ui.ListManager;
import com.ibm.etools.iseries.ui.RecordIOManager;
public class JFTSample extends JFrame {

	private javax.swing.JPanel jContentPane = null;

	private ListManager listManager = null;  //  @jve:decl-index=0:visual-constraint="227,15"
	private RecordIOManager recordIOManager = null;  //  @jve:decl-index=0:visual-constraint="116,14"
	private AS400 aS400 = null;  //  @jve:decl-index=0:visual-constraint="58,15"
	private JTextArea jTextArea = null;
	private JButton jButton = null;
	private JScrollPane jScrollPane = null;
	private JFormattedTable jFormattedTable = null;
	private JPanel jPanel = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel5 = null;
	private JTextField server = null;
	private JTextField id = null;
	private JTextField lib = null;
	private JTextField file = null;
	private JPasswordField pwd = null;
	private String serverN,idN,pwdN;
	private String libN,fileN, recordN;
	private JLabel jLabel2 = null;
	private JTextField record = null;
	private JTextField jTextField = null;
	/**
	 * This method initializes listManager	
	 * 	
	 * @return com.ibm.etools.iseries.ui.ListManager	
	 */    
	private ListManager getListManager() {
		if (listManager == null ||
				serverN.compareToIgnoreCase(getServer().getText().trim()) != 0	|| 
				idN.compareToIgnoreCase(getId().getText().trim())!=0 || 
				pwdN.compareToIgnoreCase(new String(getPwd().getPassword()).trim())!=0 ||
				libN.compareToIgnoreCase(getLib().getText().trim()) != 0	|| 
				recordN.compareToIgnoreCase(getRecord().getText().trim()) != 0	|| 
				fileN.compareToIgnoreCase(getFile().getText().trim())!=0 ) {
			libN=getLib().getText().trim();
			recordN=getRecord().getText().trim();
			fileN=getFile().getText().trim();
			serverN=getServer().getText().trim();
			idN=getId().getText().trim();
			pwdN=new String(getPwd().getPassword()).trim();
			recordIOManager=null;
			aS400=null;
			jFormattedTable=null;
			jScrollPane.setViewportView(getJFormattedTable());
			listManager = new ListManager();
			listManager.setRecordIOManager(getRecordIOManager());
			listManager.setDisplayContainer(getJFormattedTable());
		}
		return listManager;
	}
	/**
	 * This method initializes recordIOManager	
	 * 	
	 * @return com.ibm.etools.iseries.ui.RecordIOManager	
	 */    
	private RecordIOManager getRecordIOManager() {
		if (recordIOManager == null) {
			recordIOManager = new RecordIOManager();
			recordIOManager.setSystem(getAS400());
			try {
				recordIOManager.setRecordFormatName(recordN);
				recordIOManager.setLibrary(libN);
				recordIOManager.setFileName(fileN);
			} catch (PropertyVetoException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return recordIOManager;
	}
	/**
	 * This method initializes aS400	
	 * 	
	 * @return com.ibm.as400.access.AS400	
	 */    
	private AS400 getAS400() {
		if (aS400 == null) {
			aS400 = new AS400();
				aS400.setPassword(pwdN);
				try {
					aS400.setSystemName(serverN);
					aS400.setUserId(idN);
					aS400.connectService(AS400.COMMAND);
				} catch (PropertyVetoException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (AS400SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
		return aS400;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setText(
					"This sample was built using the Java Visual Editor.\n" +
					"It makes use of the ListManager, and RecordIOManager beans to retrieve the contents of \n" +
					"the specified remote iSeries table.  The results are displayed in the JFormattedTable \n" +
					"below.  It uses an AS400 object created with the entered values");
				jTextArea.setEditable(false);
				//jTextArea.setEnabled(false);
				jTextArea.setWrapStyleWord(true);
		}
		return jTextArea;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Retrieve contents of table");
			jButton.setToolTipText("Click to update table below");
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String status="";
					getJTextField().setText(status);
					getContentPane().setCursor(new Cursor(Cursor.WAIT_CURSOR));
					try {
						getListManager().readAllRecords();
					} catch (AS400Exception e1) {
						status=""+e1;
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (AS400SecurityException e1) {
						status=""+e1;
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (InterruptedException e1) {
						status=""+e1;
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (IOException e1) {
						status=""+e1;
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					getContentPane().setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
					getJTextField().setText(status);
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJFormattedTable());
			jScrollPane.setToolTipText("Contents of remote DB table will be displayed here.");
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jFormattedTable	
	 * 	
	 * @return com.ibm.etools.iseries.ui.JFormattedTable	
	 */    
	private JFormattedTable getJFormattedTable() {
		if (jFormattedTable == null) {
			jFormattedTable = new JFormattedTable();
			jFormattedTable.setEnabled(false);
			jFormattedTable.setToolTipText("Contents of remote DB table are displayed here.");
		}
		return jFormattedTable;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			jLabel2 = new JLabel();
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			jLabel5 = new JLabel();
			jLabel4 = new JLabel();
			jLabel3 = new JLabel();
			jLabel1 = new JLabel();
			jLabel = new JLabel();
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jLabel.setText("Server: ");
			gridBagConstraints18.gridx = 0;
			gridBagConstraints18.gridy = 4;
			gridBagConstraints18.anchor = java.awt.GridBagConstraints.WEST;
			jLabel1.setText("File:");
			gridBagConstraints20.gridx = 0;
			gridBagConstraints20.gridy = 3;
			gridBagConstraints20.anchor = java.awt.GridBagConstraints.WEST;
			jLabel3.setText("Library:");
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.gridy = 2;
			gridBagConstraints21.anchor = java.awt.GridBagConstraints.WEST;
			jLabel4.setText("Password: ");
			gridBagConstraints22.gridx = 0;
			gridBagConstraints22.gridy = 1;
			gridBagConstraints22.anchor = java.awt.GridBagConstraints.WEST;
			jLabel5.setText("User ID:");
			gridBagConstraints23.gridx = 0;
			gridBagConstraints23.gridy = 0;
			gridBagConstraints23.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints24.gridx = 1;
			gridBagConstraints24.gridy = 0;
			gridBagConstraints24.weightx = 1.0;
			gridBagConstraints24.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints26.gridx = 1;
			gridBagConstraints26.gridy = 1;
			gridBagConstraints26.weightx = 1.0;
			gridBagConstraints26.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints28.gridx = 1;
			gridBagConstraints28.gridy = 3;
			gridBagConstraints28.weightx = 1.0;
			gridBagConstraints28.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints29.gridx = 1;
			gridBagConstraints29.gridy = 4;
			gridBagConstraints29.weightx = 1.0;
			gridBagConstraints29.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints30.gridx = 1;
			gridBagConstraints30.gridy = 2;
			gridBagConstraints30.weightx = 1.0;
			gridBagConstraints30.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.gridy = 5;
			gridBagConstraints31.anchor = java.awt.GridBagConstraints.WEST;
			jLabel2.setText("Record name:");
			jLabel2.setToolTipText("Record name");
			gridBagConstraints32.gridx = 1;
			gridBagConstraints32.gridy = 5;
			gridBagConstraints32.weightx = 1.0;
			gridBagConstraints32.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 6;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridwidth = 2;
			jPanel.add(jLabel, gridBagConstraints23);
			jPanel.add(jLabel1, gridBagConstraints18);
			jPanel.add(jLabel3, gridBagConstraints20);
			jPanel.add(jLabel4, gridBagConstraints21);
			jPanel.add(jLabel5, gridBagConstraints22);
			jPanel.add(getServer(), gridBagConstraints24);
			jPanel.add(getId(), gridBagConstraints26);
			jPanel.add(getLib(), gridBagConstraints28);
			jPanel.add(getFile(), gridBagConstraints29);
			jPanel.add(jLabel2, gridBagConstraints31);
			jPanel.add(getRecord(), gridBagConstraints32);
			jPanel.add(getPwd(), gridBagConstraints30);
			jPanel.add(getJTextField(), gridBagConstraints1);
		}
		return jPanel;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getServer() {
		if (server == null) {
			server = new JTextField();
			server.setColumns(0);
			server.setText("MyiSeries");
			server.setToolTipText("iSeries name");
			server.setName("server");
		}
		return server;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getId() {
		if (id == null) {
			id = new JTextField();
			id.setText("MyID");
			id.setName("id");
			id.setToolTipText("User ID");
		}
		return id;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getLib() {
		if (lib == null) {
			lib = new JTextField();
			lib.setText("ADTSLAB");
			lib.setToolTipText("Library name");
		}
		return lib;
	}
	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getFile() {
		if (file == null) {
			file = new JTextField();
			file.setText("PRODUCT");
			file.setToolTipText("File name");
		}
		return file;
	}
	/**
	 * This method initializes jPasswordField	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */    
	private JPasswordField getPwd() {
		if (pwd == null) {
			pwd = new JPasswordField();
			pwd.setText("MyPwd");
			pwd.setToolTipText("password");
		}
		return pwd;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getRecord() {
		if (record == null) {
			record = new JTextField();
			record.setText("PRODUC1");
			record.setToolTipText("Record name");
		}
		return record;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setEditable(false);
			jTextField.setToolTipText("Error, if applicable, will be displayed here.");
		}
		return jTextField;
	}
                     	public static void main(String[] args) {
		JFTSample f=new JFTSample();
		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			};
		});
		f.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public JFTSample() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(535, 381);
		this.setContentPane(getJContentPane());
		this.setTitle("JFormattedTable example, built using JVE");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new GridBagLayout());
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.gridy = 0;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.weighty = 0.0D;
			gridBagConstraints12.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints12.gridwidth = 1;
			gridBagConstraints13.gridx = 0;
			gridBagConstraints13.gridy = 2;
			gridBagConstraints16.weightx = 1.0;
			gridBagConstraints16.weighty = 1.0;
			gridBagConstraints16.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints16.gridheight = 10;
			gridBagConstraints16.gridwidth = 0;
			gridBagConstraints16.gridx = 0;
			gridBagConstraints16.gridy = 3;
			gridBagConstraints17.gridx = 0;
			gridBagConstraints17.gridy = 1;
			gridBagConstraints17.fill = java.awt.GridBagConstraints.BOTH;
			jContentPane.add(getJTextArea(), gridBagConstraints12);
			jContentPane.add(getJButton(), gridBagConstraints13);
			jContentPane.add(getJScrollPane(), gridBagConstraints16);
			jContentPane.add(getJPanel(), gridBagConstraints17);
		}
		return jContentPane;
	}
}  //  @jve:decl-index=0:visual-constraint="16,58"
