package com.ibm.etools.iseries.examples.jformatted.EditcodeEditwordSample;

// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 2002 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if IBM has been
// advised of the possibility of such damages.
//


/**
 * This sample program demonstrates the use of some of the methods
 * in EditcodeEditwordFormatter bean. 
 *
 * Functions that you can perform with the example:
 * 1) Select an edit type, then select the edit code or edit word that 
 * you would like the string to be formatted in. You can also change
 * edit code parameter type and qdecfmtJValue. Data shown in the
 * first row of the table are predefined data that will be passed as
 * input parameter to method formatString(String) in 
 * EditcodeEditwordFormatter bean, and the return values are displayed 
 * in the second row of table. You will see the data appear in the 
 * second row are formatted in the editing type that you select.
 * 
 */


import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormatSymbols;
import com.ibm.etools.iseries.ui.*;



public class EditcodeEditwordSample extends javax.swing.JFrame implements
	java.awt.event.ActionListener, ItemListener
{
	private JRadioButton 	radioEditCode;
	private JRadioButton 	radioEditWord;
	private JComboBox 		comboEditCode;
	private JComboBox 		comboEditWord;
	private JComboBox 		comboEditCodeParmType;
	private JComboBox		comboQdecfmtJValue;
	private JLabel 			labelEditCode;
	private JLabel 			labelEditCodeParmType;
	private JLabel			labelQdecfmtJValue;
	private JLabel 			labelEditWord;
	private JLabel 			labelReturnData1;
	private JLabel 			labelReturnData2;
	private JLabel 			labelReturnData3;
	private JLabel 			labelReturnData4;
	private JLabel 			labelReturnData5;
	private DefaultTableModel tableModel ;
	private JTable   table;


	
	private static final String[] editCode = { 	"1", "2", "3", "4", 
												"A", "B", "C", "D", 
												"J", "K", "L", "M", 
												"N", "O", "P", "Q", 
												"W", "X", "Y", "Z" };
												
	private static final String[] parmType = { 	"None", 
												"Asterisk",
												"Currency" };
												
	private static final String[] qdecfmtJValue = { "true", "false"};
												
	private static final String[] editWord = { 	"   ,   .  ", 
												"   , 0 .  ",
												"0  :  :  ",
												"0(   )&   -    ",
												"0   /  -    " };
	private static final Object[] columns = {	"c1", "c2","c3", "c4", "c5", "c6" };
	
	private static final Object[][] data = { 
											{ "Input Data:", "1234567890","-123456789",  "0", "123456", "1234567.89" },
											{ "Return Data:", "", "", "", "", "" } 
										   };
												
/**
 * EditcodeEditwordSample constructor comment.
 */
public EditcodeEditwordSample() {
	super();


	setTitle("EditcodeEditwordSample");
	setResizable(true);
	setSize(800,350);
	
	// create content pane with GridBagLayout
	JPanel contentPane =new JPanel();
	contentPane.setLayout(null);
	setContentPane(contentPane);


	JLabel labelType = new JLabel("Edit type:");
	labelType.setForeground(Color.black);
	labelType.setBounds(10, 17, 110, 23);
	contentPane.add(labelType);


	radioEditCode = new JRadioButton("edit code");
	radioEditCode.setBounds(10, 40, 110, 23);
	radioEditCode.setSelected(true);
	contentPane.add(radioEditCode);
	
	radioEditWord = new JRadioButton("edit word");
	radioEditWord.setBounds(10, 65, 110, 23);
	contentPane.add(radioEditWord);
	
	ButtonGroup buttonGroup = new ButtonGroup();
	buttonGroup.add(radioEditCode);
	buttonGroup.add(radioEditWord);
	
	labelEditCode = new JLabel("Edit code:");
	labelEditCode.setBounds(10, 122, 110, 23);
	labelEditCode.setForeground(Color.black);
	contentPane.add(labelEditCode);
	
	comboEditCode = new JComboBox(editCode);
	comboEditCode.setBounds(130, 122, 110, 23);
	contentPane.add(comboEditCode);
	
	labelEditCodeParmType = new JLabel("Parameter Type:");
	labelEditCodeParmType.setBounds(250, 122, 110, 23);
	labelEditCodeParmType.setForeground(Color.black);
	contentPane.add(labelEditCodeParmType);
	
	comboEditCodeParmType = new JComboBox(parmType);
	comboEditCodeParmType.setBounds(370, 122, 110, 23);
	comboEditCodeParmType.setSelectedIndex(1);
	contentPane.add(comboEditCodeParmType);
	
	labelQdecfmtJValue = new JLabel("QdecfmtJValue:");
	labelQdecfmtJValue.setBounds(490, 122, 110, 23);
	labelQdecfmtJValue.setForeground(Color.black);
	contentPane.add(labelQdecfmtJValue);


	comboQdecfmtJValue = new JComboBox(qdecfmtJValue);
	comboQdecfmtJValue.setBounds(610, 122, 110, 23);
	contentPane.add(comboQdecfmtJValue);
	
	labelEditWord = new JLabel("Edit Word:");
	labelEditWord.setBounds(10, 160, 110, 23);
	labelEditWord.setForeground(Color.black);
	labelEditWord.setEnabled(false);
	contentPane.add(labelEditWord);
	
	comboEditWord = new JComboBox(editWord);
	comboEditWord.setBounds(130, 160, 110, 23);
	comboEditWord.setEnabled(false);
	contentPane.add(comboEditWord);
	
	tableModel = new DefaultTableModel(data, columns);
	table = new JTable(tableModel);
	table.setBounds(10, 230, 750, 32);
	table.setBorder(new javax.swing.border.EtchedBorder());
	contentPane.add(table);



	// Add listeners to radio buttons and combo box
	radioEditCode.addActionListener(this);	
	radioEditWord.addActionListener(this);	
	comboEditCode.addItemListener(this);	
	comboEditCodeParmType.addItemListener(this);
	comboQdecfmtJValue.addItemListener(this);	
	comboEditWord.addItemListener(this);	


}



/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		EditcodeEditwordSample aEditcodeEditwordSample;
		aEditcodeEditwordSample = new EditcodeEditwordSample();
		aEditcodeEditwordSample.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		aEditcodeEditwordSample.show();
		aEditcodeEditwordSample.setVisible(true);
		aEditcodeEditwordSample.showFormatData();
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main()");
		exception.printStackTrace(System.out);
	}
}


/**
 * actionPerformed method comment.
 */
public void actionPerformed(java.awt.event.ActionEvent e) 
{
	if (e.getSource()==radioEditCode) 
	{
		comboEditCode.setEnabled(true);
		labelEditCode.setEnabled(true);
		labelEditCodeParmType.setEnabled(true);
		comboEditCodeParmType.setEnabled(true);
		labelQdecfmtJValue.setEnabled(true);
		comboQdecfmtJValue.setEnabled(true);
		labelEditWord.setEnabled(false);
		comboEditWord.setEnabled(false);


	}
	else if (e.getSource()==radioEditWord) 
	{
		comboEditCode.setEnabled(false);
		labelEditCode.setEnabled(false);
		labelEditCodeParmType.setEnabled(false);
		comboEditCodeParmType.setEnabled(false);
		labelQdecfmtJValue.setEnabled(false);
		comboQdecfmtJValue.setEnabled(false);
		labelEditWord.setEnabled(true);
		comboEditWord.setEnabled(true);
	}	
	
	showFormatData();
}
/**
 * ItemEvent will be fired when a choice's selection is changed.
 */
public void itemStateChanged(java.awt.event.ItemEvent e) 
{
	showFormatData();
}


/**
 * Show the string returned by EditcodeEditwordFormatter in labelReturnData,
 * based on user selection of edit code, or edit word and the data.
 */
public void showFormatData()
{
	DataAttributes attributes = new DataAttributes(	
									DataAttributes.DATATYPE_NUMERIC, 
									12, 0, 
									(new DecimalFormatSymbols()).getDecimalSeparator());
									
	EditcodeEditwordFormatter formatter = new EditcodeEditwordFormatter(attributes);
	
	try
	{
		// if edit code is selected
		if (radioEditCode.isSelected())
		{
			char edtcode = comboEditCode.getSelectedItem().toString().charAt(0);
			formatter.setEditCode(edtcode);
			formatter.setEditCodeParmType(comboEditCodeParmType.getSelectedIndex());
			if (comboQdecfmtJValue.getSelectedIndex()==0)
				formatter.setQdecfmtJValue(true);
			else
				formatter.setQdecfmtJValue(false);
		}
		// else if edit word is selected
		else
		{
			formatter.setEditWord(comboEditWord.getSelectedItem().toString());
		}	
	
		// formats the strings shown in first row of table, and
		// return the formatted strings in the second row of table
		for (int i=1; i<6; i++)
		{
			attributes.setDecimalPlaces(0);
			if (i==6) attributes.setDecimalPlaces(2);
			
			data[1][i] = formatter.formatString(data[0][i].toString());
			tableModel.setValueAt(data[1][i],1,i);
		}
		
	}
	catch (Exception e)
	{
		// if exception occurred, clear return data
		for (int i=1; i<6; i++)
		{		
			data[1][i] = "";
			tableModel.setValueAt(data[1][i],1,i);
		}
		
		e.printStackTrace();
	}
}


}