//Licensed Material - Property of IBM
//(C) Copyright IBM Corp. 2004 - All Rights Reserved
//
//DISCLAIMER:
//The following [enclosed] code is sample code created by IBM
//Corporation.  This sample code is not part of any standard IBM product
//and is provided to you solely for the purpose of assisting you in the
//development of your applications.  The code is provided 'AS IS',
//without warranty of any kind.  IBM shall not be liable for any damages
//arising out of your use of the sample code, even if they have been
//advised of the possibility of such damages.

//This class extends JFrame.  It was built using the JVE.  
//Sample helps demonstrate use of remote List beans.  To use; enter the 
//server name, user, and password on the provided filds.  Clikcing one 
//the provided Pushbuttons will:
//       1. Cause respective List object to be created,
//       2. Associate List with the iSeries server
//       3. Attempt to retrieve List as specified in text field
//       4. List results, or error, on provided text area

package com.ibm.etools.iseries.examples.objectList.ve;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.etools.iseries.comm.ISeriesListFields;
import com.ibm.etools.iseries.comm.ISeriesListIFS;
import com.ibm.etools.iseries.comm.ISeriesListLibraries;
import com.ibm.etools.iseries.comm.ISeriesListMembers;
import com.ibm.etools.iseries.comm.ISeriesListObjects;
import com.ibm.etools.iseries.comm.ISeriesListRecords;
import com.ibm.etools.iseries.comm.filters.ISeriesFieldFilterString;
import com.ibm.etools.iseries.comm.filters.ISeriesIFSFilterString;
import com.ibm.etools.iseries.comm.filters.ISeriesLibraryFilterString;
import com.ibm.etools.iseries.comm.filters.ISeriesMemberFilterString;
import com.ibm.etools.iseries.comm.filters.ISeriesObjectFilterString;
import com.ibm.etools.iseries.comm.filters.ISeriesRecordFilterString;
import com.ibm.etools.iseries.comm.interfaces.IISeriesHostFieldBasic;
import com.ibm.etools.iseries.comm.interfaces.IISeriesHostObjectBasic;
import com.ibm.etools.iseries.comm.interfaces.IISeriesHostObjectBrief;
import com.ibm.etools.iseries.comm.interfaces.IISeriesHostRecordBasic;
public class AllListsSample extends JFrame {
	private String server, userID, pwd;
	private javax.swing.JPanel jContentPane = null;

	private JPanel jPanel = null;
	private JTextField jTextField = null;
	private JButton jButton = null;
	private ISeriesListMembers iSeriesListMembers = null;  //  @jve:decl-index=0:visual-constraint="172,10"
	private AS400 aS400 = null;  //  @jve:decl-index=0:visual-constraint="15,13"
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	private JTextField jTextField1 = null;
	private JTextField jTextField2 = null;
	private JTextField jTextField3 = null;
	private JTextField jTextField4 = null;
	private JTextField jTextField5 = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JPanel jPanel1 = null;
	private JLabel jLabel = null;
	private JTextField jTextField6 = null;
	private JTextField jTextField7 = null;
	private JPasswordField jPasswordField = null;
	private JButton jButton3 = null;
	private JButton jButton4 = null;
	private JButton jButton5 = null;
	private ISeriesListIFS iSeriesListIFS = null;  //  @jve:decl-index=0:visual-constraint="75,15"
	private ISeriesListLibraries iSeriesListLibraries = null;  //  @jve:decl-index=0:visual-constraint="107,58"
	private ISeriesListObjects iSeriesListObjects = null;  //  @jve:decl-index=0:visual-constraint="243,62"
	private ISeriesListRecords iSeriesListRecords = null;  //  @jve:decl-index=0:visual-constraint="312,11"
	private ISeriesListFields iSeriesListFields = null;  //  @jve:decl-index=0:visual-constraint="7,60"
	private JTextArea jTextArea1 = null;
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints91 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints81 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints71 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 6;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.gridy = 6;
			gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 11;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.weighty = 1.0;
			gridBagConstraints5.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints5.gridwidth = 2;
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridy = 9;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.gridy = 8;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.gridy = 7;
			gridBagConstraints8.weightx = 1.0;
			gridBagConstraints8.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints9.gridx = 0;
			gridBagConstraints9.gridy = 3;
			gridBagConstraints9.weightx = 1.0;
			gridBagConstraints9.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints10.gridx = 0;
			gridBagConstraints10.gridy = 2;
			gridBagConstraints10.weightx = 1.0;
			gridBagConstraints10.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.gridy = 9;
			gridBagConstraints11.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.gridy = 8;
			gridBagConstraints12.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridwidth = 2;
			gridBagConstraints71.gridx = 1;
			gridBagConstraints71.gridy = 7;
			gridBagConstraints71.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints81.gridx = 1;
			gridBagConstraints81.gridy = 3;
			gridBagConstraints81.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints91.gridx = 1;
			gridBagConstraints91.gridy = 2;
			gridBagConstraints91.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints15.weightx = 1.0;
			gridBagConstraints15.weighty = 0.0D;
			gridBagConstraints15.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints15.gridx = 0;
			gridBagConstraints15.gridy = 0;
			gridBagConstraints15.gridwidth = 2;
			jPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
			jPanel.add(getJPanel1(), gridBagConstraints1);
			jPanel.add(getJTextField(), gridBagConstraints2);
			jPanel.add(getJButton(), gridBagConstraints3);
			jPanel.add(getJScrollPane(), gridBagConstraints5);
			jPanel.add(getJTextField1(), gridBagConstraints6);
			jPanel.add(getJTextField2(), gridBagConstraints7);
			jPanel.add(getJTextField3(), gridBagConstraints8);
			jPanel.add(getJTextField4(), gridBagConstraints9);
			jPanel.add(getJTextField5(), gridBagConstraints10);
			jPanel.add(getJButton1(), gridBagConstraints11);
			jPanel.add(getJButton2(), gridBagConstraints12);
			jPanel.add(getJButton3(), gridBagConstraints71);
			jPanel.add(getJButton4(), gridBagConstraints81);
			jPanel.add(getJButton5(), gridBagConstraints91);
			jPanel.add(getJTextArea1(), gridBagConstraints15);
		}
		return jPanel;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setText("A*");
		}
		return jTextField;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Library List");
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListLibraries().setSystem(getAS400());
						List l=getISeriesListLibraries().getList(new ISeriesLibraryFilterString(getJTextField().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostObjectBasic)l.get(i)).toString()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception: "+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes iSeriesListMembers	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListMembers	
	 */    
	private ISeriesListMembers getISeriesListMembers() {
		if (iSeriesListMembers == null) {
			iSeriesListMembers = new ISeriesListMembers();
			iSeriesListMembers.setSystem(getAS400());
		}
		return iSeriesListMembers;
	}
	/**
	 * This method initializes aS400	
	 * 	
	 * @return com.ibm.as400.access.AS400	
	 */    
	private AS400 getAS400() {
		if (aS400 == null || 
				server.compareToIgnoreCase(getJTextField6().getText().trim()) != 0	|| 
				userID.compareToIgnoreCase(getJTextField7().getText().trim())!=0 || 
				pwd.compareToIgnoreCase(new String(getJPasswordField().getPassword()).trim())!=0) {
			server=getJTextField6().getText().trim();
			userID=getJTextField7().getText().trim();
			pwd=new String(getJPasswordField().getPassword()).trim();
			aS400 = new AS400();
			try {
				aS400.setSystemName(server);
				aS400.setUserId(userID);
			} catch (PropertyVetoException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			aS400.setPassword(pwd);
		}
		return aS400;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setEnabled(false);
			jTextArea.setEditable(false);
			jTextArea.setToolTipText("This TextArea displays the list, or error, resulting from the last attempt to retrieve a list.");
		}
		return jTextArea;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setText("ADTSLAB/* RCDNAME(*) OBJTYPE(*FILE:PF-DTA)");
		}
		return jTextField1;
	}
	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setText("ADTSLAB/* OBJTYPE(*FILE:PF-DTA)");
		}
		return jTextField2;
	}
	/**
	 * This method initializes jTextField3	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField3() {
		if (jTextField3 == null) {
			jTextField3 = new JTextField();
			jTextField3.setText("ADTSLAB/QCL*(*ALL) MBRTYPE(*ALL) OBJTYPE(*FILE:PF-SRC)");
		}
		return jTextField3;
	}
	/**
	 * This method initializes jTextField4	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField4() {
		if (jTextField4 == null) {
			jTextField4 = new JTextField();
			jTextField4.setText("/QIBM/ProdData/h*");
		}
		return jTextField4;
	}
	/**
	 * This method initializes jTextField5	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField5() {
		if (jTextField5 == null) {
			jTextField5 = new JTextField();
			jTextField5.setText("ADTSLAB/PRODUCT RCDNAME(PRODUC1) ");
		}
		return jTextField5;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Record List");
			jButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListRecords().setSystem(getAS400());
						List l=getISeriesListRecords().getList(new ISeriesRecordFilterString(getJTextField1().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostRecordBasic)l.get(i)).getFile()+":"+((IISeriesHostRecordBasic)l.get(i)).getName()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception: "+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton1;
	}
	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Object list");
			jButton2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListObjects().setSystem(getAS400());
						List l=getISeriesListObjects().getList(new ISeriesObjectFilterString(getJTextField2().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostObjectBasic)l.get(i)).toString()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception: "+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton2;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jLabel = new JLabel();
			java.awt.GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints61 = new GridBagConstraints();
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jLabel.setText("iSeries / userID /password:");
			gridBagConstraints21.anchor = java.awt.GridBagConstraints.NORTHWEST;
			gridBagConstraints31.gridx = 1;
			gridBagConstraints31.gridy = 0;
			gridBagConstraints31.weightx = 1.0;
			gridBagConstraints31.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.gridx = 2;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.weightx = 1.0;
			gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints61.gridx = 3;
			gridBagConstraints61.gridy = 0;
			gridBagConstraints61.weightx = 1.0;
			gridBagConstraints61.fill = java.awt.GridBagConstraints.HORIZONTAL;
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "iSeries server configuration ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jPanel1.setToolTipText("Enter iSeries server values here");
			jPanel1.add(jLabel, gridBagConstraints21);
			jPanel1.add(getJTextField6(), gridBagConstraints31);
			jPanel1.add(getJTextField7(), gridBagConstraints4);
			jPanel1.add(getJPasswordField(), gridBagConstraints61);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jTextField6	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField6() {
		if (jTextField6 == null) {
			jTextField6 = new JTextField();
			jTextField6.setText("MyiSeries");
			jTextField6.setToolTipText("Enter your iSeries server name");
		}
		return jTextField6;
	}
	/**
	 * This method initializes jTextField7	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField7() {
		if (jTextField7 == null) {
			jTextField7 = new JTextField();
			jTextField7.setText("MyID");
			jTextField7.setToolTipText("User ID");
		}
		return jTextField7;
	}
	/**
	 * This method initializes jPasswordField	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */    
	private JPasswordField getJPasswordField() {
		if (jPasswordField == null) {
			jPasswordField = new JPasswordField();
			jPasswordField.setText("MyPwd");
			jPasswordField.setToolTipText("Password");
		}
		return jPasswordField;
	}
	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Member List");
			jButton3.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListMembers().setSystem(getAS400());
						List l=getISeriesListMembers().getList(new ISeriesMemberFilterString(getJTextField3().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostObjectBasic)l.get(i)).toString()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception: "+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton3;
	}
	/**
	 * This method initializes jButton4	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("IFS List");
			jButton4.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListIFS().setSystem(getAS400());
						List l=getISeriesListIFS().getList(new ISeriesIFSFilterString(getJTextField4().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostObjectBrief)l.get(i)).toString()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception: "+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton4;
	}
	/**
	 * This method initializes jButton5	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new JButton();
			jButton5.setText("Fields List");
			jButton5.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						getISeriesListFields().setSystem(getAS400());
						List l=getISeriesListFields().getList(new ISeriesFieldFilterString(getJTextField5().getText()));
						getJTextArea().setText("");
						for (int i=0; i<l.size(); i++){
							getJTextArea().append(((IISeriesHostFieldBasic)l.get(i)).getInternalName()+"\r\n");
						}
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						getJTextArea().setText("Exception:"+e1);
						e1.printStackTrace();
					}
				}
			});
		}
		return jButton5;
	}
	/**
	 * This method initializes iSeriesListIFS	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListIFS	
	 */    
	private ISeriesListIFS getISeriesListIFS() {
		if (iSeriesListIFS == null) {
			iSeriesListIFS = new ISeriesListIFS();
		}
		return iSeriesListIFS;
	}
	/**
	 * This method initializes iSeriesListLibraries	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListLibraries	
	 */    
	private ISeriesListLibraries getISeriesListLibraries() {
		if (iSeriesListLibraries == null) {
			iSeriesListLibraries = new ISeriesListLibraries();
		}
		return iSeriesListLibraries;
	}
	/**
	 * This method initializes iSeriesListObjects	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListObjects	
	 */    
	private ISeriesListObjects getISeriesListObjects() {
		if (iSeriesListObjects == null) {
			iSeriesListObjects = new ISeriesListObjects();
		}
		return iSeriesListObjects;
	}
	/**
	 * This method initializes iSeriesListRecords	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListRecords	
	 */    
	private ISeriesListRecords getISeriesListRecords() {
		if (iSeriesListRecords == null) {
			iSeriesListRecords = new ISeriesListRecords();
			iSeriesListRecords.setListType(2);
		}
		return iSeriesListRecords;
	}
	/**
	 * This method initializes iSeriesListFields	
	 * 	
	 * @return com.ibm.etools.iseries.comm.ISeriesListFields	
	 */    
	private ISeriesListFields getISeriesListFields() {
		if (iSeriesListFields == null) {
			iSeriesListFields = new ISeriesListFields();
			iSeriesListFields.setSystem(getAS400());
			iSeriesListFields.setListType(15);
		}
		return iSeriesListFields;
	}
	/**
	 * This method initializes jTextArea1	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getJTextArea1() {
		if (jTextArea1 == null) {
			jTextArea1 = new JTextArea();
			jTextArea1.setText(
				"This sample was built using the Java Visual Editor.\n" +
				"It makes use of the various List beans to retrieve " +
				"lists of objects from the specified server.");
			jTextArea1.setEditable(false);
			jTextArea1.setEnabled(false);
			jTextArea1.setWrapStyleWord(true);
		}
		return jTextArea1;
	}
                                	public static void main(String[] args) {
    		AllListsSample f=new AllListsSample();
    		f.addWindowListener(new WindowAdapter() {
    			public void windowClosing(WindowEvent e) {
    				System.exit(0);
    			};
    		});
    		f.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public AllListsSample() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(600, 400);
		this.setContentPane(getJContentPane());
		this.setTitle("List Example, built using JVE");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.setPreferredSize(new java.awt.Dimension(600,400));
			jContentPane.add(getJPanel(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}
}  //  @jve:decl-index=0:visual-constraint="12,128"
