package com.ibm.etools.iseries.examples.toolboxdemo;


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.access.AS400Bin4;
import com.ibm.as400.access.AS400Message;
import com.ibm.as400.access.AS400Text;
import com.ibm.as400.access.CommandCall;
import com.ibm.as400.access.ProgramCall;
import com.ibm.as400.access.ProgramParameter;
import com.ibm.as400.access.QSYSObjectPathName;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This class extends JPanel.  It illustrates the use of toolbox  classes to call
// an AS/400 program, or to execute an AS/400 command.




public class CallExample extends JPanel implements ActionListener{
	
private ToolboxDemo		parentFrame;


private JLabel			l0,l0a,l0b,l0c,l0d,l0e,l0f;
private JLabel			l1;
private JTextField	t1;
private JTextField	t2=new JTextField(25);
private JTextField	t3=new JTextField(6);
private JTextField	t4=new JTextField(6);
private JTextField	t5=new JTextField(6);
private JTextField	t6=new JTextField(25);
private JTextArea    out=new JTextArea();
private JScrollPane  sp=new JScrollPane();


private JButton		commandCallPB=new JButton("Command Call");
private JButton		systemStatusPB=new JButton("Status via QWCRSSTS");
private JButton		timePB=new JButton("Time via ILE C program");


public AS400 AS400Connection=new AS400();
public String oldAS400Name="";
































































public CallExample(ToolboxDemo t) {
	parentFrame=t;
	// Initialize labels
	t1=new JTextField(parentFrame.AS400Name,9);
	l0=new  JLabel("This panel demonstrates use of Program Call, and Command Call classes in the AS/400 Java Toolkit.");
	l0a=new JLabel("");
	l1=new JLabel("AS400:");


	// Setup tool tip text:
	t1.setToolTipText("Enter name of AS/400 here");
	t2.setToolTipText("Enter AS/400 command here");
	out.setToolTipText("JTextArea used to display messages received from AS/400");
	commandCallPB.setToolTipText("Execute command on AS/400");
	systemStatusPB.setToolTipText("Refresh system status via call to QSYS/QWCRSSTS");
	timePB.setToolTipText("Refresh AS/400 time via call to ADTSLAB/GETTIME ILE-C program");
	
	// Set up listeners
	commandCallPB.addActionListener(this);
	systemStatusPB.addActionListener(this);
	timePB.addActionListener(this);


	// Disable output fields:
	t3.setEnabled(false);
	t3.setEditable(false);
	t4.setEnabled(false);
	t5.setEnabled(false);
	t6.setEnabled(false);


	// Setup log field
	sp.getViewport().add(out);
	sp.setMinimumSize(new Dimension(300,200));
	sp.setPreferredSize(new Dimension(300,250));


	// Place items on pane
	setLayout(new GridBagLayout());
	out.setEnabled(false);
	addit1(l0,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,0,1,1,1);
	addit1(l0a,0,1,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l1,1,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(t1,2,2,5,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(t2,1,3,4,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(commandCallPB,8,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(new JLabel("CPU/DASD/Jobs:"),1,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t3,2,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t4,3,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t5,4,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(systemStatusPB,8,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t6,1,7,4,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(timePB,8,7,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(new JLabel(" "),8,9,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(sp,1,10,10,1,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
  }
public void actionPerformed(ActionEvent e) {
	if(e.getSource() == commandCallPB) {
		// Attempt to execute the user specified command on the AS/400
		try {
			parentFrame.status.setText("executing command on "+t1.getText()+"....");
			if (!oldAS400Name.equals(t1.getText().trim()))
				AS400Connection=new AS400(oldAS400Name=t1.getText().trim());
			CommandCall cmd = new CommandCall(AS400Connection);
			if (cmd.run(t2.getText().trim())) {
				AS400Message[] messageList = cmd.getMessageList();
				out.append( "<<"+t2.getText().trim()+"\n" );
				// Display messages (if any) on log JTextArea
				if (messageList.length > 0) {
					for (int i=0; i < messageList.length; i++) {
						out.append( ">>" + messageList[i].getID() );
						out.append( ": " );
						out.append( messageList[i].getText() + "\n");
					}
				}
			} else
				out.append( "Command execution on "+t1.getText().trim()+ " Failed:"+t2.getText().trim()+"\n" );
		} catch (Exception ee) {
			out.append("Exception while executing command: "+ee.getMessage()+"\n");
		};
		parentFrame.status.setText("Idle");
	  }
	  if(e.getSource() == systemStatusPB) {
		// Attempt to retrieve system status via QWCRSSTS.
		try {
			parentFrame.status.setText("Getting system status via QWCRSSTS ....");
			if (!oldAS400Name.equals(t1.getText().trim()))
				AS400Connection=new AS400(oldAS400Name=t1.getText().trim());
			t3.setText("");
			t4.setText("");
			t5.setText("");
			QSYSObjectPathName programName = new QSYSObjectPathName("QSYS",
  														"QWCRSSTS",
  														"PGM");
			ProgramCall getSystemStatus = new ProgramCall(AS400Connection);
			// Setup parameters in preparation for call
			ProgramParameter[] parmlist = new ProgramParameter[5];
			parmlist[0] = new ProgramParameter( 64 ); // 1. Output, 64 bytes
			AS400Bin4 bin4 = new AS400Bin4( );        // 2. I, #
			Integer iStatusLength = new Integer( 64 );
			byte[]  statusLength = bin4.toBytes( iStatusLength );
			parmlist[1] = new ProgramParameter( statusLength );
			AS400Text text1 = new AS400Text(8,AS400Connection);       // 3. I, String
			byte[] statusFormat = text1.toBytes("SSTS0200");
			parmlist[2] = new ProgramParameter( statusFormat );
			AS400Text text3 = new AS400Text(10,AS400Connection);      // 4. I, String
			byte[] resetStats = text3.toBytes("*NO       ");
			parmlist[3] = new ProgramParameter( resetStats );
			byte[] errorInfo = new byte[32];          // 5. I/O, error
			parmlist[4] = new ProgramParameter( errorInfo, 0 );
			
			getSystemStatus.setProgram(programName.getPath(), parmlist );
			if (getSystemStatus.run()!=true) {
				// Call failed.  Notify user, and display any received messages
				AS400Message[] msgList = getSystemStatus.getMessageList();
				out.append("Call to QWCRSSTS failed ....\n");
				for (int i=0; i<msgList.length; i++)
					out.append(msgList[i].getText()+"\n");
			} else {
				// Call successfull.  Attempt to update the status fields:
				
				// Manipulate output parameter to extract information
				AS400Bin4 as400Int = new AS400Bin4( );
				byte[] as400Data = parmlist[0].getOutputData();
				// CPU utilization is numeric field at offset 32
				Integer cpuUtil = (Integer)as400Int.toObject( as400Data, 32 );
				cpuUtil = new Integer(cpuUtil.intValue()/10);
				t3.setText(cpuUtil.toString());
				// DASD utilization is numeric field at offset 52
				Integer dasdUtil = (Integer)as400Int.toObject( as400Data, 52 );
				dasdUtil = new Integer(dasdUtil.intValue()/10000);
				t4.setText(dasdUtil.toString());
				// Jobs is a numeric field at offset 36
				Integer nj = (Integer)as400Int.toObject( as400Data, 36 );
				t5.setText(nj.toString());
			}
		} catch (Exception ee) {
			out.append("Exception while calling QWCRSSTS: "+ee.getMessage()+"\n");
		};
		parentFrame.status.setText("Idle");
	  }
	  if(e.getSource() == timePB) {
		// Attempt to retrieve AS/400 time via program call to ADTSLAB/GETTIME
		try {
			parentFrame.status.setText("Getting system status via ILEC program ADTSLAB/GETTIME");
			if (!oldAS400Name.equals(t1.getText().trim()))
				AS400Connection=new AS400(oldAS400Name=t1.getText().trim());
		 	t6.setText("");
			QSYSObjectPathName programName = new QSYSObjectPathName("ADTSLAB",
																	"GETTIME",
																	"PGM");
			ProgramCall getSystemStatus = new ProgramCall(AS400Connection);
			ProgramParameter[] parmlist = new ProgramParameter[1];
			parmlist[0] = new ProgramParameter( 80 );
			getSystemStatus.setProgram(programName.getPath(), parmlist );
			if (getSystemStatus.run()!=true){
				// Call failed.  Notify user, and display any received messages
				AS400Message[] msgList = getSystemStatus.getMessageList();
				out.append("Program did not run.  Messages:\n");
				for (int i=0; i<msgList.length; i++)
					out.append(msgList[i].getText()+"\n");
			} else {
				// Call successful, update time
				AS400Text as400Text = new AS400Text(80,AS400Connection);
				byte[] as400Data = parmlist[0].getOutputData();
				String time = (String)as400Text.toObject( as400Data, 0 );
				t6.setText(time.substring(0,time.indexOf(0)-1));
			}
		} catch (Exception ee) {
			out.append("Exception while calling TIME: "+ee.getMessage()+"\n");
		};
		parentFrame.status.setText("Idle");
	  }
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
}
