package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableColumn;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;


public class SPCExample extends JPanel implements 	ActionListener	{
private ToolboxDemo		parentFrame;


// JLabel, and JTextField components
private JLabel			l0=new JLabel("This examples illustrates the use of the Toolbox to display the Stored Procedure Catalog.");
private JLabel			l1=new JLabel("AS/400");
private JLabel			l2=new JLabel("Stored Procedure Catalog:");
private JLabel			l3=new JLabel("Procedure Parameters:");
private JTextField		t1;


// declare JTable, and Jtree related components
private JTable			table,t;
private PFTableModel 	dataModel,dataModel1;
private JScrollPane		tableSP,tSP;
private JTree			tree;
private JScrollPane		treeSP;
public  DefaultMutableTreeNode top;


// pushbuttons:
private JButton			SPCPB=new JButton("Get Stored Procedure Catalog");
private JButton			parameterPB=new JButton("Get Parameters");
private JButton			endPB=new JButton("Exit");


public Connection 		as400Connection;


public SPCExample(ToolboxDemo tt) {
	parentFrame=tt;


	top = new DefaultMutableTreeNode("Stored Procedure Catalog");
	tree=new JTree(top);
	treeSP = new JScrollPane(tree);
	treeSP.setPreferredSize(new Dimension(225, 180));
	tree.setToolTipText("JTree shows the Stored Procedure Catalog for the AS/400");


	dataModel = new PFTableModel();
	table = new JTable(dataModel);
	table.setColumnSelectionAllowed(false);
	table.setToolTipText("JTable shows the Stored Procedure Catalog for the AS/400");
	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
	tableSP = new JScrollPane(table);
	tableSP.setPreferredSize(new Dimension(600, 180));
	tableSP.setMinimumSize(new Dimension(400, 180));


	dataModel1 = new PFTableModel();
	t = new JTable(dataModel1);
	t.setColumnSelectionAllowed(false);
	t.setToolTipText("JTable shows the parameters for the selected Procedure");
	t.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	t.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
	tSP = new JScrollPane(t);
	tSP.setPreferredSize(new Dimension(600, 180));
	tSP.setMinimumSize(new Dimension(400, 180));


	t1=new JTextField(parentFrame.AS400Name,9);


	SPCPB.addActionListener(this);
	SPCPB.setToolTipText("Press to have JTable populated with Stored Procedure Catalog");
	parameterPB.addActionListener(this);
	parameterPB.setToolTipText("Press to display parameters.  Tree selection takes precedence.");
	endPB.addActionListener(this);


	setLayout(new GridBagLayout());
	addit1(l0,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l1,0,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.WEST,
		1,1,1,1,1,1);
	addit1(t1,2,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.WEST,
		1,1,1,1,1,1);
	addit1(SPCPB,3,1,3,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.EAST,
		1,1,1,1,1,1);
	addit1(parameterPB,3,3,3,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.EAST,
		1,1,1,1,1,1);
	addit1(endPB,3,4,3,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.EAST,
		1,1,1,1,1,1);
	addit1(l2,0,5,3,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(treeSP,6,1,5,5,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(tableSP,0,6,12,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l3,0,7,3,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(tSP,0,8,12,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
  }
public void actionPerformed(ActionEvent e) {
	if (e.getSource() == SPCPB) {
		// Get Stored procedure catalog from selected AS/400
		try {
			ResultSet rs = null;
			String s1 = null;
			int i1;
			parentFrame.status.setText("Connecting ....");


			// Load the AS/400 Toolbox for Java JDBC driver.
			Class.forName("com.ibm.as400.access.AS400JDBCDriver");
			as400Connection = DriverManager.getConnection("jdbc:as400://" + t1.getText().trim() + "/apilib;naming=sql;errors=full;date format=iso");
			parentFrame.status.setText("Retrieving Stored Procedure Catalog ....");
			DatabaseMetaData dbMeta = as400Connection.getMetaData();
			String catalog = "myCatalog";
			String schema = "mySchema";
			String tablen = "myTable%"; // % indicates search pattern
			String types[] = {"TABLE", "VIEW", "SYSTEM TABLE"};
			// retrieve S.P.C. :
			rs = dbMeta.getProcedures(null, null, null);
			if (rs != null) {
				// setup JTable (columns, column widths, and column headings) 
				// as per metadata
				ResultSetMetaData rsmd = rs.getMetaData();
				int columnCount = rsmd.getColumnCount();
				String[] columnLabels = new String[columnCount];
				int[] columnWidths = new int[columnCount];
				for (int i = 1; i <= columnCount; ++i) {
					columnLabels[i - 1] = rsmd.getColumnLabel(i);
					columnWidths[i - 1] = Math.min(15, (Math.max(columnLabels[i - 1].length(), rsmd.getColumnDisplaySize(i))));
				}
				Object[][] d = new Object[1][columnCount];
				dataModel = new PFTableModel(columnLabels, d);
				table.setModel(dataModel);
				table.revalidate();
				String cat = "", sch = "", procedure = "";
				DefaultMutableTreeNode catN = null, schN = null;
				boolean firstTime = true;
				int j = 0;
				String[] columnData = new String[columnCount];
				top.removeAllChildren();
				// populate JTable, and tree, with S.P.C. entries :
				while (rs.next()) {
					int i;
					for (i = 1; i <= columnCount; ++i)
						columnData[i - 1] = rs.getString(i);
					if (firstTime)
						for (i = 0; i < columnCount; ++i)
							dataModel.setValueAt(columnData[i], 0, i);
						else
							dataModel.appendRow(columnData);
					firstTime = false;
					if (((String) table.getValueAt(j, 0)).equals(cat) == false) {
						cat = (String) table.getValueAt(j, 0);
						top.add(catN = new DefaultMutableTreeNode(cat));
					}
					if (((String) table.getValueAt(j, 1)).equals(sch) == false) {
						sch = (String) table.getValueAt(j, 1);
						catN.add(schN = new DefaultMutableTreeNode(sch));
					}
					schN.add(new DefaultMutableTreeNode(table.getValueAt(j, 2)));
					j++;
				}
				table.setRowSelectionInterval(0, 0);
			}
			tree.revalidate();
			table.revalidate();
			// clear parameter table:
			dataModel1 = new PFTableModel();
			t.setModel(dataModel1);
			t.revalidate();
		} catch (Exception ee) {
			System.out.println("Exception while getting S.P.C.: " + ee.getMessage());
		}
		parentFrame.status.setText("Idle.");
	}
	if (e.getSource() == parameterPB) {
		// Get Parameters for selected procedure.  
		try {
			ResultSet rs = null;
			String s1 = null;
			int i1;
			parentFrame.status.setText("Retrieving Procedure Parameters ....");
			if ((as400Connection == null) || as400Connection.isClosed()) {
				// Load the AS/400 Toolbox for Java JDBC driver.
				Class.forName("com.ibm.as400.access.AS400JDBCDriver");
				as400Connection = DriverManager.getConnection("jdbc:as400://" + t1.getText().trim() + "/apilib;naming=sql;errors=full;date format=iso");
			}
			DatabaseMetaData dbMeta = as400Connection.getMetaData();
			String catalog = "myCatalog";
			String schema = "mySchema";
			String tablen = "myTable%"; // % indicates search pattern
			String types[] = {"TABLE", "VIEW", "SYSTEM TABLE"};
			// If user has selected a procedure from the tree view of the catalog; use it.
			// Otherwise, use selection from JTable view.
			TreePath selPath = tree.getSelectionPath();
			int row = table.getSelectedRow();
			String as400pgm = (String) table.getValueAt(row, 2);
			String as400lib = (String) table.getValueAt(row, 1);
			if (selPath != null && selPath.getPathCount() == 4) { // procedure name selected
				as400lib = selPath.getPathComponent(2).toString();
				as400pgm = selPath.getPathComponent(3).toString();
			}
			// Retrieve parameters, and populate second JTable with them.
			rs = dbMeta.getProcedureColumns(null, as400lib, as400pgm, null);
			if (rs != null) {
				ResultSetMetaData rsmd = rs.getMetaData();
				int columnCount = rsmd.getColumnCount();
				String[] columnLabels = new String[columnCount];
				int[] columnWidths = new int[columnCount];
				for (int i = 1; i <= columnCount; ++i) {
					columnLabels[i - 1] = rsmd.getColumnLabel(i);
					columnWidths[i - 1] = Math.min(15, (Math.max(columnLabels[i - 1].length(), rsmd.getColumnDisplaySize(i))));
				}
				Object[][] d = new Object[1][columnCount];
				dataModel1 = new PFTableModel(columnLabels, d);
				t.setModel(dataModel1);
				TableColumn tc;
				for (int i = 0; i < columnCount; i++) {
					tc = t.getColumn(columnLabels[i]);
					//tc.setWidth(columnWidths[i]);
					dataModel1.setValueAt(" ", 0, i);
				}
				table.revalidate();
				boolean firstTime = true;
				int j = 0;
				String[] columnData = new String[columnCount];
				while (rs.next()) {
					int i;
					for (i = 1; i <= columnCount; ++i)
						columnData[i - 1] = rs.getString(i);
					if (firstTime)
						for (i = 0; i < columnCount; ++i)
							dataModel1.setValueAt(columnData[i], 0, i);
						else
							dataModel1.appendRow(columnData);
					firstTime = false;
					j++;
				}
			}
		} catch (Exception ee) {
			System.out.println("ERROR: " + ee.getMessage());
		}
		t.revalidate();
		parentFrame.status.setText("Idle.");
	}
	if (e.getSource() == endPB) {
		System.exit(0);
	}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
}
