package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This class extends JPanel.  It illustrates the use of the 4 types of toolbox
// panes.  Panes are populated with AS/400 user information.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.vaccess.AS400DetailsPane;
import com.ibm.as400.vaccess.AS400ExplorerPane;
import com.ibm.as400.vaccess.AS400ListPane;
import com.ibm.as400.vaccess.AS400TreePane;
import com.ibm.as400.vaccess.ErrorDialogAdapter;
import com.ibm.as400.vaccess.VUserList;


public class UserExample extends JPanel implements ActionListener{


private ToolboxDemo		parentFrame;


// Labels and text fields:
private JLabel			l1,l1A,l2;
private JTextField		t2;


// Pushbuttons:
private JButton		populatePB=new JButton("Get users");
private JButton		endPB=new JButton("Exit");


// VAccess controls
private AS400ListPane 		listPane=new AS400ListPane();
private AS400DetailsPane 	detailsPane=new AS400DetailsPane();
private AS400TreePane 		treePane=new AS400TreePane();
private AS400ExplorerPane	explorerPane=new AS400ExplorerPane();
private VUserList			userList;


public AS400 				AS400Connection=new AS400();


// This error handler is shared by all components.
private static ErrorDialogAdapter errorHandler;
































// Constructor
public UserExample(ToolboxDemo t) {
	parentFrame=t;
	
	t2=new JTextField(parentFrame.AS400Name,9);
	l1=new  JLabel( "This page demonstrates the different types of panes supported by the Toolbox.  All are populated with user list.");
	l1A=new  JLabel(" ");
	l2=new JLabel("AS400:");
	populatePB.setToolTipText("Populate panes with AS/400 User List");


	// Set up listeners
	populatePB.addActionListener(this);
	endPB.addActionListener(this);


	// Show any errors to the user.
	errorHandler = new ErrorDialogAdapter (parentFrame);


	listPane.addErrorListener (errorHandler);
	listPane.setPreferredSize(new Dimension(200,140));
	listPane.setMinimumSize(new Dimension(200,120));
	treePane.setPreferredSize(new Dimension(200,140));
	treePane.setMinimumSize(new Dimension(200,120));
	detailsPane.setPreferredSize(new Dimension(600,140));
	detailsPane.setMinimumSize(new Dimension(400,120));
	explorerPane.setPreferredSize(new Dimension(700,140));
	explorerPane.setMinimumSize(new Dimension(400,120));


	// Position items on pane
	setLayout(new GridBagLayout());
	addit1(l1,0,0,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(l1A,0,1,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,0,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t2,2,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(populatePB,5,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
//	addit1(endPB,6,3,1,1,
//		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
//		1,1,1,1,1,1);
	addit1(new JLabel("AS400ListPane:"),0,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(listPane,0,6,3,2,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(new JLabel("AS400TreePane:"),5,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(treePane,5,6,3,2,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(new JLabel("AS400DetailsPane:"),0,11,2,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(detailsPane,0,12,10,2,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(new JLabel("AS400ExplorerPane:"),0,14,2,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		10,10,1,1,1,1);
	addit1(explorerPane,0,15,10,2,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
}
public void actionPerformed(ActionEvent e) {
	try {
		if(e.getSource() == populatePB) {
	 		// Populate all panes with User List from specified AS/400
			parentFrame.status.setText("Retrieving user list from "+t2.getText()+ " ....");
			AS400Connection= new AS400(t2.getText().trim());
			AS400Connection.connectService(AS400.FILE);
			userList = new VUserList (AS400Connection);
			parentFrame.status.setText("Updating panes ....");
			listPane.setRoot(userList);
			listPane.setAllowActions(true);
			listPane.load();
			treePane.setRoot(userList);
			treePane.setAllowActions(true);
			treePane.load();
			detailsPane.setRoot(userList);
			detailsPane.setAllowActions(true);
			detailsPane.load();
			explorerPane.setRoot(userList);
			explorerPane.setAllowActions(true);
			explorerPane.load();
			parentFrame.status.setText("Idle");
	  	}
		if(e.getSource() == endPB) {
			System.exit(0);
  		}
   } catch(Exception e1) {
   	System.out.println("Exception:"+e1.getMessage());
	}


}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
}
